MODULE instrument_constants
  ! SIZE: buffer size = SIZE*work_index
  integer(KIND=4), parameter :: SIZE      = 512
end MODULE instrument_constants
MODULE subbers
  contains
    subroutine subber_in( buf )
      character, dimension(:,:,:), intent( in ) :: buf
      call arg_passing_sub( buf, SIZE, SIZE, SIZE )
    end subroutine subber_in
    subroutine subber_inout( buf )
      character, dimension(:,:,:), intent( inout ) :: buf
      call arg_passing_sub( buf, SIZE, SIZE, SIZE )
    end subroutine subber_inout
    subroutine subber_out( buf )
      character, dimension(:,:,:), intent( out ) :: buf
      call arg_passing_sub( buf, SIZE, SIZE, SIZE )
    end subroutine subber_out
    subroutine subber_ass( buf )
      character, dimension(*), intent( in ) :: buf
      call arg_passing_sub( buf, SIZE, SIZE, SIZE )
    end subroutine subber_ass
end MODULE subbers
program arg_passing
  use instrument_constants
  use subbers
  IMPLICIT NONE
  integer(KIND=4) :: i
  integer(KIND=KIND(1_8)) :: heap_size
  character(len=50) :: place
  integer :: istat
  character, dimension(:,:,:), allocatable :: buf
  allocate( buf(SIZE,SIZE,SIZE) )
  call PROCMON_INFO_GET_PRINT( 'main:all'//ACHAR(0), 0 )
  call arg_passing_sub( buf, SIZE, SIZE, SIZE )
  call PROCMON_INFO_GET_PRINT( 'main:all'//ACHAR(0), 1 )
  call PROCMON_INFO_GET_PRINT( 'subber_in'//ACHAR(0), 0 )
  call subber_in( buf )
  call PROCMON_INFO_GET_PRINT( 'subber_in'//ACHAR(0), 1 )
  call PROCMON_INFO_GET_PRINT( 'subber_inout'//ACHAR(0), 0 )
  call subber_inout( buf )
  call PROCMON_INFO_GET_PRINT( 'subber_inout'//ACHAR(0), 1 )
  call PROCMON_INFO_GET_PRINT( 'subber_out'//ACHAR(0), 0 )
  call subber_out( buf )
  call PROCMON_INFO_GET_PRINT( 'subber_out'//ACHAR(0), 1 )
  call PROCMON_INFO_GET_PRINT( 'subber_ass'//ACHAR(0), 0 )
  call subber_ass( buf )
  call PROCMON_INFO_GET_PRINT( 'subber_ass'//ACHAR(0), 1 )
  deallocate(buf)
end program arg_passing
