/* ------------- */
/* include files */
/* ------------- */
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#if defined( _PROCMON_UPS )
#include "ups.h"
#else
#if defined( _PROCMON_SERIAL )
#else
#include "mpi.h"
#endif
#endif
int main(int argc, char **argv)
{
  int
    ierr = 0,
    numpes,
    penum;
  /* init and get process number */
#if defined( _PROCMON_UPS )
  ierr = UPS_AA_Init( argc, argv );
  assert( !ierr );
  ierr = UPS_CM_Get_penum( &penum );
  assert( !ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  ierr = MPI_Init( &argc, &argv );
  assert( !ierr );
  ierr = MPI_Comm_rank( MPI_COMM_WORLD, &penum );
  assert( !ierr );
  ierr = MPI_Comm_size( MPI_COMM_WORLD, &numpes );
  assert( !ierr );
#endif
#endif
  fprintf( stderr, "hello from %d of %d\n", penum, numpes );
  /* terminate */
#if defined( _PROCMON_UPS )
  ierr = UPS_AA_Terminate();
  assert( !ierr );
#else
#if defined( _PROCMON_SERIAL )
  penum = 0;
#else
  ierr = MPI_Finalize();
  assert( !ierr );
#endif
#endif
  return( ierr );
}
